<?php

namespace Drupal\mailgroup\EventSubscriber;

use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Drupal\mailgroup\Event\MailGroupMessageEvent;

/**
 * Subscribe to mail group message events.
 */
class MailGroupMessageEventSubscriber implements EventSubscriberInterface {

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents() {
    return [
      MailGroupMessageEvent::CREATE => 'sendMessage',
    ];
  }

  /**
   * Send a message to group members.
   *
   * @param \Drupal\mailgroup\Event\MailGroupMessageEvent $event
   *   The message event.
   */
  public function sendMessage(MailGroupMessageEvent $event) {
    /** @var \Drupal\mailgroup\Entity\MailGroupMessage $message */
    $message = $event->getMessage();

    /** @var \Drupal\mailgroup\Entity\MailGroup $group */
    $group = $message->getGroup();
    $group->sendMessage([
      'sender' => $message->getSender(),
      'subject' => $message->getSubject(),
      'body' => $message->getBody(),
    ]);
  }

}
